program example;

uses
  Classes;

type

  { TSomeParent }

  TSomeParent = class( TPersistent )
    procedure SomeProcedure; virtual;
  end;

  { TSomeParent }

  { TSomeOtherParent }

  TSomeOtherParent = class( TPersistent )
    procedure SomeProcedure; virtual;
  end;

{$MACRO ON}
{$DEFINE T:= TSomeParent}
{$DEFINE TTestClass:= TMyTestClassWithSomeParent}
{$DEFINE INTERFACE}
{$INCLUDE testclass.inc}
{$UNDEF INTERFACE}
{$UNDEF T}
{$UNDEF TTestClass}

{$MACRO ON}
{$DEFINE T:= TSomeOtherParent}
{$DEFINE TTestClass:= TMyTestClassWithSomeOtherParent}
{$DEFINE INTERFACE}
{$INCLUDE testclass.inc}
{$UNDEF INTERFACE}
{$UNDEF T}
{$UNDEF TTestClass}


{$DEFINE T:= TSomeParent}
{$DEFINE TTestClass:= TMyTestClassWithSomeParent}
{$DEFINE IMPLEMENTATION}
{$INCLUDE testclass.inc}
{$UNDEF IMPLEMENTATION}
{$UNDEF T}
{$UNDEF TTestClass}

{$DEFINE T:= TSomeOtherParent}
{$DEFINE TTestClass:= TMyTestClassWithSomeOtherParent}
{$DEFINE IMPLEMENTATION}
{$INCLUDE testclass.inc}
{$UNDEF IMPLEMENTATION}
{$UNDEF T}
{$UNDEF TTestClass}

{ TSomeOtherParent }

procedure TSomeOtherParent.SomeProcedure;
begin
  WriteLn( 'TSomeOtherParent.Some procedure' );
end;



{ TSomeParent }

procedure TSomeParent.SomeProcedure;
begin
  WriteLn( 'TSomeParent.Some procedure' );
end;

begin
  with ( TMyTestClassWithSomeParent.Create ) do begin
    SomeProcedure;
    Free;
  end;
  with ( TMyTestClassWithSomeOtherParent.Create ) do begin
    SomeProcedure;
    Free;
  end;
end.

